addpath c:\dynare\4.5.5\matlab
// TESTE


var 
c_p       // 1  PATIENT   HHs
h_p       // 2  PATIENT   HHs
d_p       // 3  PATIENT   HHs
l_p       // 4  PATIENT   HHs
lam_p     // 5  PATIENT   HHs
J_R       // 6  PATIENT   HHs
j_B       // 7  PATIENT   HHs
pie_wp    // 8  PATIENT   HHs  
c_i       // 9  IMPATIENT HHs
h_i       // 10 IMPATIENT HHs
b_i       // 11 IMPATIENT HHs 
l_i       // 12 IMPATIENT HHs
lam_i     // 13 IMPATIENT HHs
s_i       // 14 IMPATIENT HHs
pie_wi    // 15 IMPATIENT HHs
I         // 16 CAPITAL PRODUCERS
q_k       // 17 CAPITAL PRODUCERS
c_e       // 18 ENTREPRENEURS
y_e       // 23 ENTREPRENEURS
lam_e     // 24 ENTREPRENEURS
s_e       // 25 ENTREPRENEURS
u         // 26 ENTREPRENEURS Capital utilization rate
b_e       // 29 BANKS
r_d       // 30 BANKS
r_bh      // 31 BANKS
r_be      // 32 BANKS
R_b       // 33 BANKS
K_b       // 34 BANKS
pie       // 35 RETAILERS
x         // 36 RETAILERS
C         // 37 AGGREGATION & EQUILIBRIUM
Y         // 38 AGGREGATION & EQUILIBRIUM
B         // 42 AGGREGATION & EQUILIBRIUM
w_p       // 43 AGGREGATION & EQUILIBRIUM
w_i       // 44 AGGREGATION & EQUILIBRIUM
q_h       // 46 AGGREGATION & EQUILIBRIUM
K         // 47 AGGREGATION & EQUILIBRIUM
PIW       // 48 AGGREGATION & EQUILIBRIUM
r_ib      // 49 MONETARY POLICY
r_k       // 50 CAPITAL RENTAL RATE
ee_z      // 51 EXOGENOUS PROCESSES
A_e       // 52 EXOGENOUS PROCESSES
ee_j      // 53 EXOGENOUS PROCESSES
mk_d      // 54 EXOGENOUS PROCESSES
mk_be     // 55 EXOGENOUS PROCESSES
mk_bh     // 56 EXOGENOUS PROCESSES
ee_qk     // 57 EXOGENOUS PROCESSES
m_i       // 58 EXOGENOUS PROCESSES (IMPATIENT LTV)
m_e       // 59 EXOGENOUS PROCESSES (ENTREPRENEURS LTV)
eps_y     // 60 EXOGENOUS PROCESSES
eps_l     // 61 EXOGENOUS PROCESSES
eps_K_b   // 62 EXOGENOUS PROCESSES
rr_e      // 64 Entrep. Real Rate
aux1      // 65 auxiliary variable
bm        // 66 banks intermediation margins
spr_b     // 67 average bank spread (active-passive)

Ih
ee_qh
s_iw
m_iw
r_bw
b_iw
mk_bw
h_e
h

pQ
Q
er
premium
Rstar
Bstar
ystar
pie_star
y_exp
eps_premium
y
ee_pi //parameters of entrepreneurs
;

varexo e_z e_A_e e_j e_mi e_me e_mk_d e_mk_be e_mk_bh e_qk e_y e_r_ib e_l e_eps_K_b e_miw e_mk_bw e_qh e_pQ e_pie_star e_Rstar e_ystar e_eps_premium;


parameters  beta_p j phi beta_i m_i_ss beta_e m_e_ss eksi_1 eksi_2    // HOUSEHOLDS & ENTREPRENEURS
            a_i a_p a_e ni                     // HOUSEHOLDS & ENTREPRENEURS
            eps_l_ss kappa_w                                                // HOUSEHOLDS (labor params)
            eps_d eps_bh eps_be                                             // BANKS 
            mk_d_ss mk_bh_ss mk_be_ss r_be_ss  r_bh_ss r_k_ss               // BANKS (SS)
            beta_b delta_kb vi kappa_kb                              // BANKS 
            eps_y_ss kappa_p ind_p ind_w                                    // RETAILERS
            kappa_i kappa_d kappa_be kappa_bh deltak                        // OTHERS
            rho_ib phi_pie phi_y                                            // POLICY
            piss  r_ib_ss                                                   // STEADY STATE
            rho_ee_z rho_A_e rho_ee_j rho_mi rho_me rho_eps_y rho_ee_pi               // SHOCKS
            rho_mk_d rho_mk_be rho_mk_bh rho_ee_qk rho_eps_l rho_eps_K_b    // SHOCKS
            ind_d ind_be ind_bh                                             // OTHERS

            deltah eps_bw mk_bw_ss r_bw_ss kappa_ih kappa_bw ind_bw m_iw_ss
            rho_miw rho_mk_bw rho_ee_qh
            Rstar_ss ystar_ss pie_star_ss alphak alphal chi tau
            zeta rho_ystar rho_pie_star rho_Rstar rho_pQ rho_eps_premium
            ;

% *********************			
% CALIBRATED PARAMETERS
% *********************

beta_p       = 0.989; //0.9943;                                                     % discount factor patient households
beta_i       = 0.96; //0.975; "Iacoviello 2005"                                                    % discount factor impatient households     
beta_b       = beta_p;                                                     % discount factor bankers (not used in this version of the model)
beta_e       = beta_i;                                                     % discount factor entrepreneurs
j            = 0.2;                                                        % weight of housing in utility function
phi          = 1.0;                                                        % inverse Frisch elasticity of labor supply
m_i_ss       = 0.06;//0.15;//0.7  ;                                               % loan-to-value ratio impatient households
m_e_ss       = 0.007;//0.085;//0.35 ;                                              % loan-to-value ratio entrepreneurs
%alpha        = 0.40; //0.250; "SW Br"                                      % capital share in the production function

eps_d        = -2.62;//-12.624223124295;//-1.46025;                                   % elast. of subst. of deposits 
eps_bh       = 5.36;//5.3561509445936;//
eps_be       = 2.73;//2.7328233013319;// 

mk_d_ss      = eps_d   / (eps_d  - 1) ;                                    % steady state markdown on D (ok if eps_d<0; if eps_d>0 it should be eps_d/(eps_d+1) )
mk_bh_ss     = eps_bh  / (eps_bh - 1) ;                                    % steady state markup on loans to I
mk_be_ss     = eps_be  / (eps_be - 1) ;                                    % steady state markup on loans to E
eps_y_ss     = 11; //6;                                                    % 
eps_l_ss     = 3; //5;                                                     % 
ni           = 0.8;                                                        % wage share of patient households
deltak       = 0.035; //0.025;                                             % depreciation rate for physical capital
piss         = 1;//1.045^0.25; //                                            % steady state gross inflation rate
r_ib_ss      = (piss/beta_p - 1) * (eps_d-1)/eps_d ;                       % steady state gross nominal interest rate 
r_be_ss      = r_ib_ss*eps_be/(eps_be-1) ;								   % steady state interest rate on loans to E
r_bh_ss      = r_ib_ss*eps_bh/(eps_bh-1) ;								   % steady state interest rate on loans to H
r_k_ss       = -(1-deltak)-m_e_ss*(1-deltak)*piss/beta_e*
               (1/(1+r_be_ss)-beta_e/piss)+1/beta_e;                       % steady state rental rate of capital
eksi_1       = r_k_ss;                                                     % capital utilization cost parameter
eksi_2       = 0.1*r_k_ss;                                                 % capital utilization cost parameter

vi           =  0.17; //0.09;                                                      % Banking Capital ratio over Loans (Basel II)
delta_kb     = 0.095; //0.094364024331655;


ind_d        = 0.0;                   % indexation deposit rates
ind_be       = 0.0;                   % indexation rates on loans to firms
ind_bh       = 0.0;                   % indexation rates on loans to households


% ********************			
% ESTIMATED PARAMETERS
% ********************

//Put median values of priors estimated before.

load median_values00.txt;
coeffs = median_values00;

rho_ee_z	=	coeffs(1);  % 0.385953438168178	;
rho_A_e     =	coeffs(2);  % 0.93816527333294	;
rho_ee_j	=	coeffs(3);  % 0.921872719102206	;
rho_me      =	coeffs(4);  % 0.90129485520182	;
rho_mi      =	coeffs(5);  % 0.922378382753078	;
rho_mk_d	=	coeffs(6);  % 0.892731352899547	;
rho_mk_bh	=	coeffs(7);  % 0.851229673864555	;
rho_mk_be	=	coeffs(8);  % 0.873901213475799	;
rho_ee_qk	=	coeffs(9);  % 0.571692383714171	;
rho_eps_y	=	coeffs(10); % 0.294182239567384	;
rho_eps_l	=	coeffs(11); % 0.596186440884132	;
rho_eps_K_b	=	coeffs(12); % 0.813022758608552	;
kappa_p     =	coeffs(13); % 33.7705265016395	;
kappa_w     =   kappa_p;
kappa_i     =	coeffs(15); % 10.0305562248008	;
kappa_d     =	coeffs(16); //100; % 2.77537377104213	;
kappa_be	=	coeffs(17); //100; % 7.98005959044637	;
kappa_bh	=	coeffs(18); //140; % 9.04426718749482	;
kappa_kb	=	coeffs(19); % 8.91481958034669	;
phi_pie     =	coeffs(20); % 2.00384780180824    ;
rho_ib      =	coeffs(21); % 0.750481873084311	;
phi_y       =	coeffs(22); % 0.303247771697294	;
ind_p       =	coeffs(23); % 0.158112794106546	;
ind_w       =	coeffs(24); % 0.300197804017489	;
a_i	        =	coeffs(25); % 0.867003766306404	;
rho_ee_pi   =   0.14891881;
a_e         =   0.0     ;   % degree of habit formation: entrepreneurs
a_p         =   0.0     ;   % degree of habit formation: patient households

deltah = 0.025; 
eps_bw = 4.5;
mk_bw_ss = eps_bw/(eps_bw - 1); 
r_bw_ss = (eps_bw/(eps_bw - 1))*r_ib_ss;
kappa_ih = kappa_i;
kappa_bw = kappa_bh;
ind_bw = ind_bh;
m_iw_ss = 0.1;
rho_miw = rho_mi;
rho_mk_bw = rho_miw;
rho_ee_qh = rho_ee_qk;

Rstar_ss = 0.005;
ystar_ss = 2;
pie_star_ss = 1;
alphak = 0.4;
alphal = 0.5;
zeta = -0.1;
chi = 0.1;
tau = -1.1;
rho_ystar = 0.9;
rho_pie_star = 0.9;
rho_Rstar = 0.9;
rho_pQ = 0.9;
rho_eps_premium = 0.9;

//%------------------------------------------------------------
//% Model equations
//%------------------------------------------------------------

model;

////***********   1) PATIENT HHs ********************************************************6

  (1-a_i)*ee_z*(c_p - a_i*c_p(-1))^(-1) = lam_p; 

  j * ee_j / h_p - lam_p * q_h + (1 - deltah) * beta_p * lam_p(+1) * q_h(+1)   = 0; // 

  lam_p  = beta_p * lam_p(+1) * (1 + r_d) / pie(+1); // 

  (1 - eps_l) * l_p + l_p ^(1+phi) / w_p * eps_l/lam_p - kappa_w *( pie_wp - pie(-1) ^ ind_w * piss ^ (1-ind_w) ) * pie_wp +  beta_p * lam_p(+1)/lam_p * kappa_w *( pie_wp(+1) - pie ^ ind_w * piss ^ (1-ind_w) ) * pie_wp(+1) ^2 / pie = 0 ;

  pie_wp = w_p / w_p(-1) * pie;

  c_p + q_h * ( h_p - (1 - deltah)*h_p(-1) ) + d_p = w_p * l_p + (1+r_d(-1))*d_p(-1)/pie + J_R ;

////***********   2) IMPATIENT HHs ********************************************************7

  (1-a_i)*ee_z*(c_i - a_i*c_i(-1))^(-1) = lam_i; // CON rescaling

   j * ee_j / h_i - lam_i * q_h + (1 - deltah) * ( beta_i * lam_i(+1) * q_h(+1) + s_i * m_i *q_h(+1) * pie(+1) ) = 0;    // 

   lam_i - beta_i * lam_i(+1) * (1 + r_bh) / pie(+1) = s_i * (1 + r_bh); // 

   lam_i - beta_i * lam_i(+1) * (1 + r_bw) / pie(+1) = s_iw * (1 + r_bw); // 

  (1 - eps_l) * l_i + eps_l * l_i^(1 + phi) / (w_i * (lam_i + m_iw * s_iw)) - kappa_w *( pie_wi - pie(-1) ^ ind_w * piss ^ (1 - ind_w) ) * pie_wi +  beta_i * (lam_i(+1) + s_iw(+1) + m_iw(+1))/(lam_i + s_iw + m_iw) * kappa_w *( pie_wi(+1) - pie ^ ind_w * piss ^ (1 - ind_w) ) * pie_wi(+1)^2 / pie(+1) = 0 ;

   pie_wi = w_i / w_i(-1) * pie;

   c_i + q_h * (h_i - (1 - deltah) * h_i(-1)) + (1 + r_bh(-1))*b_i(-1)/pie + (1 + r_bw(-1))*b_iw(-1)/pie = w_i * l_i + b_i + b_iw ;

   (1 + r_bh) * b_i = m_i * q_h(+1) *h_i * pie(+1);     //
 
   (1 + r_bw) * b_iw = m_iw * w_i(+1) * l_i(+1) * pie(+1);     // 


////***********  3) CAPITAL PRODUCERS *****************************************************

 (K) = (1-deltak) *  (K(-1)) + ( 1 - kappa_i/2 * ( (I)* (ee_qk)/ (I(-1)) - 1)^2 ) *  (I) ;   

1 =  (q_k) * ( 1 -  kappa_i/2 * ( (I)* (ee_qk)/ (I(-1)) - 1)^2  - kappa_i * ( (I)* (ee_qk)/ (I(-1)) - 1) *  (I)* (ee_qk)/ (I(-1)) ) 
  + beta_e *  (lam_e(+1)) /  (lam_e) *  (q_k(+1)) *   kappa_i * ( (I(+1))* (ee_qk(+1))/ (I) - 1) *  (ee_qk(+1)) * ( (I(+1))/ (I))^2 ; //

////***********  3) HOUSING PRODUCERS *****************************************************

 h = (1 - deltah) * h(-1) + ( 1 - kappa_ih/2 * ( Ih*ee_qh/ I(-1) - 1)^2 ) * Ih ;   

1 =  (q_h) * ( 1 -  kappa_ih/2 * ( (Ih)* (ee_qh)/ (Ih(-1)) - 1)^2  - kappa_ih * ( (Ih)* (ee_qh)/ (Ih(-1)) - 1) *  (Ih)* (ee_qh)/ (Ih(-1)) ) 
  + beta_e *  (lam_e(+1)) /  (lam_e) *  (q_h(+1)) *   kappa_ih * ( (Ih(+1))* (ee_qh(+1))/ (Ih) - 1) *  (ee_qh(+1)) * ( (Ih(+1))/ (Ih))^2 ; //

////************  4) ENTREPRENEURS *********************************************************

  (1-a_i)*ee_pi*( (c_e) - a_i* (c_e(-1)))^(-1) =  (lam_e);         // CON rescaling

  s_e * m_e * q_k(+1) * pie(+1) * (1 - deltak) + beta_e * lam_e(+1) * (  (q_k(+1))*(1-deltak) +  (r_k(+1))* (u(+1)) - ( eksi_1*( (u(+1))-1) + eksi_2/2*( ( u(+1) - 1)^2 ) ) ) = lam_e * q_k ; 

  j * ee_j / h_e - lam_e * q_h + (1 - deltah) * ( beta_e * lam_e(+1) * q_h(+1) + s_e * m_e *q_h(+1) * pie(+1) ) = 0;  

  w_p = ni * alphal * y_e / ( l_p * x );

  w_i = (1 - ni) * alphal * y_e / ( l_i * x );

  er*pQ = (1 - alphak - alphal) * y_e / ( Q * x );

  lam_e - s_e  * (1 + r_be) = beta_e * lam_e(+1) * (1 + r_be) / pie(+1);  //

  r_k  = eksi_1 + eksi_2 * (u - 1);//

  c_e + ((1 + r_be(-1)) * (b_e(-1)) / pie ) + q_h * (h_e - (1 - deltah) * h_e(-1)) +  w_p * l_p + w_i * l_i + q_k * K  + ( eksi_1*( u - 1 ) + eksi_2/2*( u - 1 )^2 ) * K(-1) + er*pQ*Q = y_e / x +  b_e +  q_k * (1 - deltak) * K(-1)  ;

  y_e = A_e * (u * K(-1))^(alphak) * ( (l_p)^ni * (l_i)^(1 - ni) ) ^ (alphal) * (Q)^ (1 - alphak - alphal);

 (1 + r_be) * b_e = m_e * ( q_k(+1) * pie(+1) * K * (1 - deltak) + q_h(+1) * pie(+1) * h_e * (1 - deltah) ); //

  r_k = alphak * A_e *  (u)^(alphak - 1) *  (K(-1))^(alphak - 1) * (  (l_p)^ni *  (l_i)^(1 - ni) ) ^ (alphal)  * (Q)^ (1 - alphak - alphal) / x;  

////*************  5)BANKS ****************************************************************

 R_b = - kappa_kb * ( K_b / B - vi ) * ( K_b/ B)^2 + r_ib ; 

// Eq. alterada para gerar choque no Kb
 K_b * pie = (1 - delta_kb) * K_b(-1)/ eps_K_b + j_B(-1) ;

// Eq. alterada para gerar choque no Kb
 b_i + b_iw + b_e = d_p + er*Bstar + K_b;

// Premio de risco
premium = exp(-zeta*er*Bstar/K_b)*eps_premium;

// Paridade das taxas de juros

(1 + Rstar) * premium * (1 - zeta*er*Bstar/K_b) * (er(+1)/er) * (pie(+1)/pie_star(+1)) = 1 + r_ib;

/// PRICING in terms of MK ///

- 1 +  (mk_d)/( (mk_d)-1)  -  (mk_d)/( (mk_d)-1)  *  (r_ib)/ (r_d)  - kappa_d  * (  (r_d)/ (r_d(-1)) - 1  )  *  (r_d)/ (r_d(-1)) 
  + beta_p * (  (lam_p(+1))/ (lam_p) ) * kappa_d  * (  (r_d(+1))/ (r_d) - (  (r_d)/ (r_d(-1)))^ind_d )   * ( ( (r_d(+1))/ (r_d))^2 )   * ( (d_p(+1))/ (d_p)) = 0;// 
  
+ 1 -  (mk_be)/( (mk_be)-1)  +   (mk_be)/( (mk_be)-1)  *  (R_b)/ (r_be) - kappa_be * ( (r_be)/ (r_be(-1)) - 1 ) *  (r_be)/ (r_be(-1)) 
  + beta_p * (  (lam_p(+1))/ (lam_p) ) * kappa_be * (  (r_be(+1))/ (r_be) - (  (r_be)/ (r_be(-1)))^ind_be ) * ( ( (r_be(+1))/ (r_be))^2 ) * ( (b_e(+1))/ (b_e)) = 0;//   30
  
+ 1 -  (mk_bh)/( (mk_bh)-1)  +   (mk_bh)/( (mk_bh)-1)  *  (R_b)/ (r_bh) - kappa_bh * ( (r_bh)/ (r_bh(-1)) - 1 ) *  (r_bh)/ (r_bh(-1)) 
  + beta_p * (  (lam_p(+1))/ (lam_p) ) * kappa_bh * (  (r_bh(+1))/ (r_bh) - (  (r_bh)/ (r_bh(-1)))^ind_bh ) * ( ( (r_bh(+1))/ (r_bh))^2 ) * ( (b_i(+1))/ (b_i)) = 0;//

+ 1 -  (mk_bw)/( (mk_bw)-1)  +   (mk_bw)/( (mk_bw)-1)  *  (R_b)/ (r_bw) - kappa_bw * ( (r_bw)/ (r_bw(-1)) - 1 ) *  (r_bw)/ (r_bw(-1)) 
  + beta_p * (  (lam_p(+1))/ (lam_p) ) * kappa_bw * (  (r_bw(+1))/ (r_bw) - (  (r_bw)/ (r_bw(-1)))^ind_bw ) * ( ( (r_bw(+1))/ (r_bw))^2 ) * ( (b_iw(+1))/ (b_iw)) = 0;//


 j_B = + r_bh * b_i
       + r_bw * b_iw
       + r_be * b_e
       + er * Bstar
       - r_d * d_p           
       - kappa_d/2 * ( ( r_d / r_d(-1) - 1)^2) * r_d * d_p 
       - kappa_be/2 * ( ( r_be / r_be(-1) - 1)^2) * r_be * b_e 
       - kappa_bh/2 * ( ( r_bh / r_bh(-1) - 1)^2) * r_bh * b_i
       - kappa_bw/2 * ( ( r_bw / r_bw(-1) - 1)^2) * r_bw * b_iw
       - kappa_kb/2 * ( ( K_b / B  - vi )^2) * K_b
       - (1 + Rstar(-1)) * premium(-1) * er * Bstar(-1);

////***********  6)RETAILERS **************************************************************

 J_R  =  y*(1 - (1/ x)    - (kappa_p/2) * ( (pie) - (  (pie(-1)) ^ ind_p * piss ^ (1-ind_p) ))^2 ) ;

1 -  (eps_y) +  (eps_y) /  (x) -    kappa_p * ( (pie) - (  (pie(-1)) ^ ind_p * piss ^ (1-ind_p) )) *  (pie) 
    + beta_p*( (lam_p(+1))/ (lam_p))* kappa_p * ( (pie(+1)) - (  (pie)     ^ ind_p * piss ^ (1-ind_p) )) *  (pie(+1)) * ( (y(+1))/ (y)) = 0;  // 34

////************  7) AGGREGATION & EQUILIBRIUM  ************************************************

 C              = c_p + c_i + c_e;
 y_exp          = chi*(1/er)^(-tau) * ystar;
 y_exp - er * pQ * Q - ((1 + Rstar(-1))/pie_star) * premium(-1) * er * Bstar(-1) = er * Bstar - er * Bstar(-1)/pie_star;
 h              = h_p + h_i + h_e; //
 B              = b_i + b_iw + b_e; //
 y              = C + ( K - (1-deltak)* K(-1)) + ( h - (1 - deltah)* h(-1)) + y_exp;
 Y              = y - er * pQ * Q;
 PIW            = (  w_p +  w_i )  / (  w_p(-1) +  w_i(-1) ) *  pie;

////***********  8) TAYLOR RULE & PROFITS CB *****************************************************                                                  

(1+ (r_ib)) = (1+r_ib_ss)^(1 - rho_ib ) * (1+ (r_ib(-1)))^rho_ib * ((  (pie) / piss ) ^phi_pie *  
             ( (Y)/ (Y(-1)))^phi_y  ) ^ ( 1 - rho_ib ) * (1+e_r_ib) ;//   48

////***********  9) EXOGENOUS PROCESSES ****************************************************12

 ee_z     = (1 - rho_ee_z)   *    1          + rho_ee_z   *  ee_z(-1)    + e_z;
 ee_pi    = (1-rho_ee_pi) * 1+ rho_ee_pi*ee_pi(-1)+ e_z; 
 A_e      = (1 - rho_A_e)    *    1          + rho_A_e    *  A_e(-1)     + e_A_e;
 ee_j     = (1 - rho_ee_j)   *    1          + rho_ee_j   *  ee_j(-1)    + e_j;
 m_i      = (1 - rho_mi)     *  m_i_ss       + rho_mi     *  m_i(-1)     + e_mi;
 m_iw     = (1 - rho_miw)    *  m_iw_ss      + rho_miw    *  m_iw(-1)    + e_miw;
 m_e      = (1 - rho_me)     *  m_e_ss       + rho_me     *  m_e(-1)     + e_me;
 mk_d     = (1 - rho_mk_d)   * mk_d_ss       + rho_mk_d   *  mk_d(-1)    + e_mk_d;
 mk_be    = (1 - rho_mk_be)  * mk_be_ss      + rho_mk_be  *  mk_be(-1)   + e_mk_be;
 mk_bh    = (1 - rho_mk_bh)  * mk_bh_ss      + rho_mk_bh  *  mk_bh(-1)   + e_mk_bh;
 mk_bw    = (1 - rho_mk_bw)  * mk_bw_ss      + rho_mk_bw  *  mk_bw(-1)   + e_mk_bw;
 ee_qk    = (1 - rho_ee_qk)  *    1          + rho_ee_qk  *  ee_qk(-1)   + e_qk;
 ee_qh    = (1 - rho_ee_qh)  *    1          + rho_ee_qh  *  ee_qh(-1)   + e_qh;
 eps_y    = (1 - rho_eps_y)  * eps_y_ss      + rho_eps_y  *  eps_y(-1)   + e_y;
 eps_l    = (1 - rho_eps_l)  * eps_l_ss      + rho_eps_l  *  eps_l(-1)   + e_l;
 eps_K_b  = (1 - rho_eps_K_b)*    1          + rho_eps_K_b*  eps_K_b(-1) + e_eps_K_b;
 
 eps_premium  = (1 - rho_eps_premium)*    1  + rho_eps_premium*  eps_premium(-1) + e_eps_premium;
 pQ       = (1 - rho_pQ)     *    1          + rho_pQ     *  pQ(-1)      + e_pQ;
 Rstar    = (1 - rho_Rstar)  * Rstar_ss      + rho_Rstar  *  Rstar(-1)   + e_Rstar;
 ystar    = (1 - rho_ystar)  * ystar_ss      + rho_ystar  *  ystar(-1)   + e_ystar;
 pie_star = (1 - rho_pie_star)* pie_star_ss  + rho_pie_star*  pie_star(-1) + e_pie_star;

////***********  10) AUXILIARY VARIABLES *****************************************************4

 rr_e     = (1 + r_be)/ pie(+1) - 1;
 aux1     = C + K -(1 - deltak)*K(-1) + h -(1 - deltah)*h(-1);
 bm       = ( b_i(-1)/( b_i(-1) + b_iw(-1) + b_e(-1) ) * r_bh(-1) +  b_iw(-1)/( b_i(-1) + b_iw(-1) + b_e(-1) ) * r_bw(-1) +  b_e(-1)/( b_i(-1) + b_iw(-1) + b_e(-1) ) *  r_be(-1) ) -  r_d(-1);
 spr_b    =  (1/3)*r_bh + (1/3)*r_be + (1/3)*r_bw - r_d;

end;

initval; 

pie = 1;
pie_wp = 1;
pie_wi = 1;
PIW = 1;
u = 1;
q_k = 1;
q_h = 1;
ee_z = 1;
A_e = 1;
ee_j = 1;
ee_qk = 1;
eps_K_b = 1;
ee_qh = 1;
eps_premium = 1;
pQ = 1;
pie_star = 1;
Rstar = 0.005;
ystar = 2;
r_d = 0.0111;
r_bh = 0.0189;
r_bw = 0.0198;
r_be = 0.0243;
R_b = 0.0154;
r_ib = 0.0154;
r_k = r_k_ss;
x = 1.1;
mk_d = mk_d_ss;
mk_be = mk_be_ss;
mk_bh = mk_bh_ss;
mk_bw = mk_bw_ss;
m_i = 0.06;
m_e = 0.007;
m_iw = 0.1;
eps_y = 11;
eps_l = 3;

lam_p = 1.5861;
lam_i = 7.5585;
lam_e = 3.4739;
s_i = 0.1622;
s_iw = 0.1559;
s_e = 0.0567;
c_p = 0.6305;
c_i = 0.1323;
c_e = 0.2879;
h_p = 3.5296;
h_i = 0.4217;
h_e = 0.9011;
d_p = 0.077;
b_i = 0.0242;
b_iw = 0.0141;
b_e = 0.0555;
l_p = 0.7793;
l_i = 0.8515;
w_p = 0.737;
w_i = 0.1686;
I = 0.262584;
Ih = 0.12131;
K = 7.5024;
K_b = 0.0159;
y_e = 1.5794;
h = 4.8524;
C = 1.0507;
Y = 1.4354;
B = 0.0938;
rr_e = 0.0243;
aux1 = 1.434594;
bm = 0.01113;
spr_b = 0.0098;
J_R = 0.143536;
j_B = 0.001511;
Bstar = 0.0006;
Q = 0.0971;
er = 1.479;
premium = 1.0052;
y_exp = 0.1444;
y = 1.5789;

end;

//// COMPUTE THE SS /////
steady;


%%%% get the SS values %%%%
ss_vector = oo_.steady_state;
n_vars    = length(ss_vector);
ss_cell   = mat2cell(ss_vector,ones(1,n_vars));
tmp       = [M_.endo_names,ones(n_vars,1)*44]';
varnames  = ['[',tmp(:)',']'];
eval([varnames,' = deal(ss_cell{:});'])

                 
disp(' ');disp('%%% Display some SS results (BK model): %%%%')
SSexpenditures  =  (C) +  (q_k) * ( (K)-(1-deltak)* (K)) + ...
                         + delta_kb *  (K_b) /  (pie) + ...
                         + (eksi_1*( (u)-1) + eksi_2/2*(( (u)-1)^2))* (K) + ...
                         + kappa_kb/2 * ( ( (K_b) /  (B)  - vi ) ^2) *  (K_b);
SSincome        =  (Y);
disp(['expenditures in ss: ',num2str(SSexpenditures)]);
disp(['total income in ss: ',num2str(SSincome)]);
disp(['C/Y: ',num2str( (C)/ (Y))]);
disp(['Ik/Y: ',num2str( (I)/ (Y))]);
disp(['Ih/Y: ',num2str( (Ih)/ (Y))]);
disp(['I/Y: ',num2str( (I + Ih)/ (Y))]);
disp(['K/Y: ',num2str( (K)/ (Y))]);
disp(['H/Y: ',num2str( (h)/ (Y))]);
disp(['erBstar/Y: ',num2str( er*Bstar/ (Y))]);
disp(['Exp/Y: ',num2str( y_exp/ (Y))]);
disp(['Imp/Y: ',num2str( er*pQ*Q/ (Y))]);
disp(['r_d (%annual): ',num2str( (r_d)*400)]);
disp(['r_ib (%annual): ',num2str( (r_ib)*400)]);
disp(['r_bh (%annual): ',num2str( (r_bh)*400)]);
disp(['r_bw (%annual): ',num2str( (r_bw)*400)]);
disp(['r_be (%annual): ',num2str( (r_be)*400)]);
disp(['spread(%annual): ',num2str( (spr_b)*400)]);
disp(['bi/(bi+biw+be)(%): ',num2str( b_i /( b_i + b_iw + b_e)*100)]);
disp(['biw/(bi+biw+be)(%): ',num2str( b_iw /( b_i + b_iw + b_e)*100)]);
disp(['be/(bi+biw+be)(%): ',num2str( b_e /( b_i + b_iw + b_e)*100)]);
disp(['B/Y: ',num2str( (B)/ (Y))]);
disp(['D/Y: ',num2str( (d_p)/ (Y))]);
disp(['K_b/B: ',num2str( (K_b)/ (B))]);
disp(['K_b/Y: ',num2str( (K_b)/ (Y))]);

disp(['delta_kb: ',num2str(delta_kb)]);
disp(['check_i: ',num2str(beta_i*(1+ (r_bh))/piss)]);
disp(['check_e: ',num2str(beta_e*(1+ (r_be))/piss)]);
disp(['w_i*l_i: ',num2str( (w_i)* (l_i))]);
disp(['w_p*l_p: ',num2str( (w_p)* (l_p))]);
disp(['w_i: ',num2str( (w_i))]);
disp(['w_p: ',num2str( (w_p))]);


shocks;
//estimated st.dev.

var e_z         = 0.0144^2;
var e_A_e       = 0.185807999596714^2;
var e_j         = 0.0658^2;
var e_me        = 0.0034^2;
var e_mi        = 0.0023^2;
var e_miw       = 0.0023^2;
var e_mk_d      = 0.0488^2;
var e_mk_bh     = 0.0051^2;
var e_mk_bw     = 0.0051^2;
var e_mk_be     = 0.1454^2;
var e_qk        = 0.0125^2;
var e_qh        = 0.0125^2;
var e_r_ib      = 0.0013^2;
var e_y         = 1.0099^2;
var e_l         = 0.3721^2;
var e_eps_K_b   = 0.050^2;
var e_pQ        = 0.050^2;
var e_eps_premium    = 0.050^2;
var e_Rstar     = 0.050^2;
var e_ystar     = 0.050^2;
var e_pie_star  = 0.050^2;

end;
model_diagnostics;
//TO BE INSERTED: ESTIMATED ST.DEV.

// Stochastic simulations 
//options_.nograph   = 0;
//options_.nomoments = 1;
//options_.noprint   = 1;
//stoch_simul(order=1,irf=20);

//%------------------------------------------------------------
//% BAYESIAN ESTIMATION  
//%------------------------------------------------------------

//% defining which dataseries are used in estimation

varobs Bstar ;

estimated_params ;

//%               Initial conditions    PRIOR shape     MEAN     STD
stderr e_z       ,       1.000,       inv_gamma_pdf,   1.0000,   5.00  ; //0.0100,   0.05  ;      
stderr e_A_e     ,70000000.000,       inv_gamma_pdf,   1.0000,   5.00  ; //0.0100,   0.05  ;  
stderr e_j       ,       2.000,       inv_gamma_pdf,   1.0000,   5.00  ; //0.0100,   0.05  ;  
stderr e_me      ,      0.3000,       inv_gamma_pdf,   1.0000,   5.00  ; //0.0100,   0.05  ;  
stderr e_mi      ,      0.4100,       inv_gamma_pdf,   1.0000,   5.00  ; //0.0100,   0.05  ;  
stderr e_mk_d    ,        0.09,       inv_gamma_pdf,   1.0000,   5.00  ; //0.0100,   0.05  ;  
stderr e_mk_bh   ,      0.0049,       inv_gamma_pdf,   1.0000,   5.00  ; //0.0100,   0.05  ;  
stderr e_mk_be   ,      0.0835,       inv_gamma_pdf,   1.0000,   5.00  ; //0.0100,   0.05  ;	//10
stderr e_qk      ,      0.0136,       inv_gamma_pdf,   1.0000,   5.00  ; //0.0100,   0.05  ;      
stderr e_r_ib    ,      0.0020,       inv_gamma_pdf,   1.0000,   5.00  ; //0.0100,   0.05  ;  
stderr e_y       ,        0.90,       inv_gamma_pdf,   1.0000,   5.00  ; //0.0100,   0.05  ;	
stderr e_l       ,       0.348,       inv_gamma_pdf,   1.0000,   5.00  ; //0.0100,   0.05  ;	
stderr e_eps_K_b ,       0.008,       inv_gamma_pdf,   1.0000,   5.00  ; //0.0100,   0.05  ;	
stderr e_pQ      ,       0.008,       inv_gamma_pdf,   1.0000,   5.00  ; //0.0100,   0.05  ;	
stderr e_eps_premium ,   0.008,       inv_gamma_pdf,   1.0000,   5.00  ; //0.0100,   0.05  ;	
stderr e_Rstar   ,       0.008,       inv_gamma_pdf,   1.0000,   5.00  ; //0.0100,   0.05  ;	
stderr e_ystar   ,       0.008,       inv_gamma_pdf,   1.0000,   5.00  ; //0.0100,   0.05  ;	
stderr e_pie_star,       0.008,       inv_gamma_pdf,   1.0000,   5.00  ; //0.0100,   0.05  ;	
stderr e_miw     ,       0.008,       inv_gamma_pdf,   1.0000,   5.00  ; //0.0100,   0.05  ;	
stderr e_qh      ,       0.008,       inv_gamma_pdf,   1.0000,   5.00  ; //0.0100,   0.05  ;	
rho_ee_z         ,        0.55,            beta_pdf,     0.50,   0.25  ; //0.80,   0.10  ;                  
rho_A_e          ,        0.95,            beta_pdf,     0.50,   0.25  ; //0.80,   0.10  ;                   
rho_ee_j         ,        0.98,            beta_pdf,     0.50,   0.25  ; //0.80,   0.10  ;
rho_me           ,        0.95,            beta_pdf,     0.50,   0.25  ; //0.80,   0.10  ;
rho_mi           ,        0.95,            beta_pdf,     0.50,   0.25  ; //0.80,   0.10  ;                   
rho_mk_d         ,        0.95,            beta_pdf,     0.50,   0.25  ; //0.80,   0.10  ;                   
rho_mk_bh        ,        0.85,            beta_pdf,     0.50,   0.25  ; //0.80,   0.10  ;                 
rho_mk_be        ,        0.85,            beta_pdf,     0.50,   0.25  ; //0.80,   0.10  ;                
rho_ee_qk        ,        0.55,            beta_pdf,     0.50,   0.25  ; //0.80,   0.10  ;              
rho_eps_y        ,        0.80,            beta_pdf,     0.50,   0.25  ; //0.80,   0.10  ;              
rho_eps_l        ,        0.60,            beta_pdf,     0.50,   0.25  ; //0.80,   0.10  ;                 
rho_eps_K_b      ,        0.80,            beta_pdf,     0.50,   0.25  ; //0.80,   0.10  ;    
rho_ystar        ,        0.80,            beta_pdf,     0.50,   0.25  ; //0.80,   0.10  ;    
rho_pie_star     ,        0.80,            beta_pdf,     0.50,   0.25  ; //0.80,   0.10  ;    
rho_Rstar        ,        0.80,            beta_pdf,     0.50,   0.25  ; //0.80,   0.10  ;    
rho_pQ           ,        0.80,            beta_pdf,     0.50,   0.25  ; //0.80,   0.10  ;    
rho_eps_premium  ,        0.80,            beta_pdf,     0.50,   0.25  ; //0.80,   0.10  ;    
rho_miw          ,        0.80,            beta_pdf,     0.50,   0.25  ; //0.80,   0.10  ;    
rho_ee_qh        ,        0.80,            beta_pdf,     0.50,   0.25  ; //0.80,   0.10  ;    
kappa_p 		 ,          50,           gamma_pdf,       50,    20   ;   			
kappa_w 		 ,          50,           gamma_pdf,       50,    20   ;			
kappa_i 		 ,         4.5,           gamma_pdf,      2.5,    1.0  ;			
kappa_ih 		 ,         4.5,           gamma_pdf,      2.5,    1.0  ;			
kappa_d 		 ,          10,           gamma_pdf,       10,    2.5  ;
kappa_be		 ,           3,           gamma_pdf,        3,    2.5  ;
kappa_bh		 ,           6,           gamma_pdf,        6,    2.5  ;
kappa_bw		 ,           6,           gamma_pdf,        6,    2.5  ;
kappa_kb         ,           5,           gamma_pdf,     10.0,    5.0  ;
phi_pie          ,         2.0,           normal_pdf,     2.0,    0.35 ; //gamma_pdf,      2.0,    0.5  ; 
rho_ib           ,        0.75,            beta_pdf,      0.6,    0.15 ; //0.75,    0.10 ; 
phi_y            ,         0.2,          gamma_pdf,      0.25,    0.10  ; //normal_pdf,     0.10,    0.15 ;    
ind_p            ,        0.20,            beta_pdf,     0.65,    0.20 ; //0.50,    0.15 ;
ind_w            ,        0.25,            beta_pdf,     0.65,    0.20 ; //0.50,    0.15 ;
a_i              ,         0.6,            beta_pdf,     0.85,    0.05 ; //beta_pdf,     0.50,    0.10 ;

end;

estimation(datafile = data_M1
                ,mode_compute = 6 %9
              //  ,mode_file    = estimation_GNSS_BK_hp_mode
                ,mh_jscale    = 0.30            
                ,presample    = 1
                ,prefilter    = 0
                ,prior_trunc  = 0 //1e-14
                ,mh_replic    = 100000
                ,mh_nblocks   = 2
                ,filtered_vars
                ,lik_init     = 1
                ,order        = 1
                ,mode_check
                ,irf=40
                ,bayesian_irf
                );